std::discrete_distribution< _IntType > Class Template Reference

## Classes

struct | param_type

## Public Types

typedef _IntType | result_type

## Public Member Functions

template<typename _InputIterator >
| discrete_distribution (_InputIterator __wbegin, _InputIterator __wend)
| discrete_distribution (const param_type &__p)
| discrete_distribution (initializer_list< double > __wl)
template<typename _Func >
| discrete_distribution (size_t __nw, double __xmin, double __xmax, _Func __fw)
template<typename _ForwardIterator , typename _UniformRandomNumberGenerator >
void | __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng)
template<typename _ForwardIterator , typename _UniformRandomNumberGenerator >
void | __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
template<typename _UniformRandomNumberGenerator >
void | __generate (result_type *__f, result_type *__t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
result_type | max () const
result_type | min () const
template<typename _UniformRandomNumberGenerator >
result_type | operator() (_UniformRandomNumberGenerator &__urng)
template<typename _UniformRandomNumberGenerator >
result_type | operator() (_UniformRandomNumberGenerator &__urng, const param_type &__p)
param_type | param () const
void | param (const param_type &__param)
std::vector< double > | probabilities () const
void | reset ()

## Friends

template<typename _IntType1 , typename _CharT , typename _Traits >
std::basic_ostream< _CharT, _Traits > & | operator<< (std::basic_ostream< _CharT, _Traits > &__os, const std::discrete_distribution< _IntType1 > &__x)
bool | operator== (const discrete_distribution &__d1, const discrete_distribution &__d2)
template<typename _IntType1 , typename _CharT , typename _Traits >
std::basic_istream< _CharT, _Traits > & | operator>> (std::basic_istream< _CharT, _Traits > &__is, std::discrete_distribution< _IntType1 > &__x)

## Detailed Description

### template<typename _IntType = int>
class std::discrete_distribution< _IntType >

A discrete_distribution random number distribution.

The formula for the discrete probability mass function is

Definition at line 5279 of file random.h.

## Member Typedef Documentation

## result_type

template<typename _IntType = int>

typedef _IntType std::discrete_distribution< _IntType >::result_type

The type of the range of the distribution.

Definition at line 5286 of file random.h.

## Member Function Documentation

## max()

template<typename _IntType = int>

result_type std::discrete_distribution< _IntType >::max | ( |  | ) | const

inline

Returns the least upper bound value of the distribution.

Definition at line 5404 of file random.h.

References std::vector< _Tp, _Alloc >::empty(), and std::vector< _Tp, _Alloc >::size().

## min()

template<typename _IntType = int>

result_type std::discrete_distribution< _IntType >::min | ( |  | ) | const

inline

Returns the greatest lower bound value of the distribution.

Definition at line 5397 of file random.h.

## operator()()

template<typename _IntType = int>
template<typename _UniformRandomNumberGenerator >

result_type std::discrete_distribution< _IntType >::operator() | ( | _UniformRandomNumberGenerator & | __urng | ) |

inline

Generating functions.

Definition at line 5415 of file random.h.

## param() [1/2]

template<typename _IntType = int>

param_type std::discrete_distribution< _IntType >::param | ( |  | ) | const

inline

Returns the parameter set of the distribution.

Definition at line 5382 of file random.h.

## param() [2/2]

template<typename _IntType = int>

void std::discrete_distribution< _IntType >::param | ( | const param_type & | __param | ) |

inline

Sets the parameter set of the distribution.

Parameters

  __param | The new parameter set of the distribution.

Definition at line 5390 of file random.h.

## probabilities()

template<typename _IntType = int>

std::vector<double> std::discrete_distribution< _IntType >::probabilities | ( |  | ) | const

inline

Returns the probabilities of the distribution.

Definition at line 5372 of file random.h.

References std::vector< _Tp, _Alloc >::empty().

## reset()

template<typename _IntType = int>

void std::discrete_distribution< _IntType >::reset | ( |  | ) |

inline

Resets the distribution state.

Definition at line 5365 of file random.h.

## Friends And Related Function Documentation

## operator<<

template<typename _IntType = int>
template<typename _IntType1 , typename _CharT , typename _Traits >

std::basic_ostream<_CharT, _Traits>& operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const std::discrete_distribution< _IntType1 > & | __x
| ) |  |

friend

Inserts a discrete_distribution random number distribution `__x` into the output stream `__os`.

Parameters

  __os | An output stream.
  __x | A discrete_distribution random number distribution.

Returns
  The output stream with the state of `__x` inserted or in an error state.

## operator==

template<typename _IntType = int>

bool operator== | ( | const discrete_distribution< _IntType > & | __d1,
|  | const discrete_distribution< _IntType > & | __d2
| ) |  |

friend

Return true if two discrete distributions have the same parameters.

Definition at line 5450 of file random.h.

## operator>>

template<typename _IntType = int>
template<typename _IntType1 , typename _CharT , typename _Traits >

std::basic_istream<_CharT, _Traits>& operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | std::discrete_distribution< _IntType1 > & | __x
| ) |  |

friend

Extracts a discrete_distribution random number distribution `__x` from the input stream `__is`.

Parameters

  __is | An input stream.
  __x | A discrete_distribution random number generator engine.

Returns
  The input stream with `__x` extracted or in an error state.

The documentation for this class was generated from the following files:

- random.h
- bits/random.tcc